Attribute VB_Name = "SubClassing"
'This demo by Alex Vallat 2000.  You may free distribute this code as long as
'this header message remains intact.  Email the author at AlexV@ComPorts.com
'More programs and demos can be found at http://www.comports.com/AlexV

Option Explicit

'API Declares as found in Win32api.txt
Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Declare Function RegisterWindowMessage Lib "user32.dll" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long
Declare Function MapViewOfFile Lib "kernel32" (ByVal hFileMappingObject As Long, ByVal dwDesiredAccess As Long, ByVal dwFileOffsetHigh As Long, ByVal dwFileOffsetLow As Long, ByVal dwNumberOfBytesToMap As Long) As Long
Declare Function UnmapViewOfFile Lib "kernel32" (lpBaseAddress As Any) As Long
Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Declare Function OpenFileMapping Lib "kernel32.dll" Alias "OpenFileMappingA" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal lpName As String) As Long
Global Const FILE_MAP_READ As Long = &H4
'winproc list location
Public Const GWL_WNDPROC = -4

'Global Vars
Global lpPrevWndProc As Long
Global gHW As Long
Global HwndFileMapObject As Long 'Handle of FMO
Global FileViewHwnd As Long 'Pointer to file view in process' virtual memory

Public Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    
    If uMsg = WM_MYMESSAGE Then
        Dim Buffer As String
        Buffer = String(lParam, "0") 'Make buffer string the length of the incomming string as obtained in lparam
        HwndFileMapObject = OpenFileMapping(FILE_MAP_READ, False, "StringFile")
        If HwndFileMapObject <> 0 Then FileViewHwnd = MapViewOfFile(HwndFileMapObject, FILE_MAP_READ, 0, 0, 0)
        'Copy the string sent from the memory map to the buffer
        CopyMem ByVal StrPtr(Buffer), ByVal FileViewHwnd, ByVal lParam * 2
        'Display the string in the buffer
        frmReciever.txtRecieved.Text = Buffer
        'Return 0
        WindowProc = 0
    Else
        WindowProc = CallWindowProc(lpPrevWndProc, gHW, uMsg, wParam, lParam)
    End If
    
End Function

Public Function WM_MYMESSAGE() As Long
'register custom windows message upon first use and obtain issued system wide unique ID upon subsequent call
Static msg As Long
    
    If msg = 0 Then
        msg = RegisterWindowMessage("WM_MYMESSAGE")
    End If
    WM_MYMESSAGE = msg
    
End Function

